/*
 * Copyright (C) 2021 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "RemoteWebInspectorUIProxy.h"

#include "ArgumentCoders.h"
#include "Decoder.h"
#include "HandleMessage.h"
#include "RemoteWebInspectorUIProxyMessages.h"
#include "WebCoreArgumentCoders.h"
#include <WebCore/CertificateInfo.h>
#include <WebCore/FloatRect.h>
#include <WebCore/InspectorFrontendClient.h>
#include <wtf/text/WTFString.h>

namespace WebKit {

void RemoteWebInspectorUIProxy::didReceiveMessage(IPC::Connection& connection, IPC::Decoder& decoder)
{
    Ref protectedThis { *this };
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::FrontendLoaded::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::FrontendLoaded>(connection, decoder, this, &RemoteWebInspectorUIProxy::frontendLoaded);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::FrontendDidClose::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::FrontendDidClose>(connection, decoder, this, &RemoteWebInspectorUIProxy::frontendDidClose);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::Reopen::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::Reopen>(connection, decoder, this, &RemoteWebInspectorUIProxy::reopen);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::ResetState::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::ResetState>(connection, decoder, this, &RemoteWebInspectorUIProxy::resetState);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::BringToFront::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::BringToFront>(connection, decoder, this, &RemoteWebInspectorUIProxy::bringToFront);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::Save::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::Save>(connection, decoder, this, &RemoteWebInspectorUIProxy::save);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::Append::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::Append>(connection, decoder, this, &RemoteWebInspectorUIProxy::append);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::SetForcedAppearance::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::SetForcedAppearance>(connection, decoder, this, &RemoteWebInspectorUIProxy::setForcedAppearance);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::SetSheetRect::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::SetSheetRect>(connection, decoder, this, &RemoteWebInspectorUIProxy::setSheetRect);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::StartWindowDrag::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::StartWindowDrag>(connection, decoder, this, &RemoteWebInspectorUIProxy::startWindowDrag);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::OpenURLExternally::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::OpenURLExternally>(connection, decoder, this, &RemoteWebInspectorUIProxy::openURLExternally);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::ShowCertificate::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::ShowCertificate>(connection, decoder, this, &RemoteWebInspectorUIProxy::showCertificate);
    if (decoder.messageName() == Messages::RemoteWebInspectorUIProxy::SendMessageToBackend::name())
        return IPC::handleMessage<Messages::RemoteWebInspectorUIProxy::SendMessageToBackend>(connection, decoder, this, &RemoteWebInspectorUIProxy::sendMessageToBackend);
    UNUSED_PARAM(connection);
    UNUSED_PARAM(decoder);
#if ENABLE(IPC_TESTING_API)
    if (connection.ignoreInvalidMessageForTesting())
        return;
#endif // ENABLE(IPC_TESTING_API)
    ASSERT_NOT_REACHED_WITH_MESSAGE("Unhandled message %s to %" PRIu64, IPC::description(decoder.messageName()), decoder.destinationID());
}

} // namespace WebKit
